6 ' Interface to a DS1302 RTC
8 ' Maximite Basic by Anthony Vine 2011
10 ce=20 ' clock enable pin
12 clk=19 ' clock pin
14 din = 18 ' read pin
16 dout = 18 ' write pin. normally is same as din
18 SETPIN ce,9
20 SETPIN clk,9
22 ' SETPIN din,2 'only required for different din/dout
24 SETPIN dout,9
26 PIN(ce)=0
28 PIN(clk)=0
30 PIN(dout)=0
32 INPUT "(r)ead and set time/date (rb)read byte (w)rite (e)nd";inp$
34 IF inp$="r" THEN GOSUB 200
36 IF inp$="w" THEN GOSUB 2000
38 IF inp$="rb" THEN GOSUB 400
40 IF inp$="e" THEN END
42 GOTO 32
44 '
200 ' ----- read -------
202 PRINT "old time ";TIME$
205 bitdata$="10000101":GOSUB 250: hr$=hi$+lo$
210 bitdata$="10000011":GOSUB 250: min$=hi$+lo$
215 bitdata$="10000001":GOSUB 250: sec$=hi$+lo$
220 TIME$ = hr$+":"+min$+":"+sec$ : PRINT "new time ";TIME$
225 bitdata$="10000111":GOSUB 250: dat$=hi$+lo$
230 bitdata$="10001001":GOSUB 250: mnt$=hi$+lo$
235 bitdata$="10001101":GOSUB 250: year$="20"+hi$+lo$
240 PRINT dat$;"/";mnt$;"/";year$ : DATE$=dat$+"/"+mnt$+"/"+year$
245 RETURN
249 '
250 'read byte required and process
251 'data is in 2 x 4 bit nibbles
254 dataout$ = ""
255 GOSUB 1000
260 FOR p = 1 TO 8 STEP 4 'this sets the first bit to read. 1 or 5
265 REM PRINT MID$(dataout$,p,4);
270 bitval = VAL(MID$(dataout$,p,1))
275 bitval=bitval + 2 * (VAL(MID$(dataout$,p+1,1)))
280 bitval=bitval + 4 * (VAL(MID$(dataout$,p+2,1)))
285 bitval=bitval + 8 * (VAL(MID$(dataout$,p+3,1)))
290 REM PRINT bitval;"   ";
295 IF p=1 THEN lo$=STR$(bitval) ELSE hi$=STR$(bitval)
300 bitval = 0
305 NEXT p
310 RETURN
400 ' ----- read single byte only ----
405 INPUT "read byte";bitdata$
410 GOSUB 250
415 PRINT hi$;lo$;"  ";
420 FOR i = 8 TO 1 STEP -1
425 PRINT MID$(dataout$,i,1);
430 NEXT i
435 PRINT
440 RETURN
445 END
1000 ' ------ read from RTC --------
1005 PIN(ce)=1
1009 'step 1. write address to read
1010 FOR i = 8 TO 1 STEP -1
1015 bit =VAL(MID$(bitdata$,i,1))
1020 PIN(dout)=bit
1025 PIN(clk)=1
1030 IF i>1 THEN PIN(clk)=0 'must leave clk high on transistion from write to r
1035 NEXT i
1040 PIN(dout)=1 'must leave dout high to be able to read din
1044 'step 2. read data coming back
1045 FOR i = 1 TO 8
1050 PIN(clk)=0 ' read is on the fall of the clock
1055 dataout$=dataout$+STR$(PIN(din))
1060 PIN(clk)=1
1065 NEXT i
1070 PIN(ce)=0
1075 PIN(dout)=0
1080 PIN(clk)=0
1085 RETURN
1090 REM
2000 REM ------ write to RTC --------
2005 PIN(ce)=1
2010 PIN(clk)=0
2015 INPUT "write address";bitdata$
2020 INPUT "data";wbitdata$
2025 FOR c = 1 TO 2 '2 bytes to write
2030 FOR i = 8 TO 1 STEP -1
2035 bit=VAL(MID$(bitdata$,i,1))
2040 PIN(dout)=bit
2045 PIN(clk)=1
2050 PIN(clk)=0
2055 NEXT i
2060 bitdata$=wbitdata$
2065 NEXT c
2070 PAUSE 10
2075 PIN(ce)=0
2080 PIN(dout)=0
2085 PIN(clk)=0
2090 RETURN
